# __Network +__ 

# __OSI Model__
## __Layer 1__ Bites 
  * Physical Layer 
    * It is the connects like Cat 6 RJ45 and fiber.
    * Its the on and off on the cables.
---

## __Layer 2__ - Frames
* ### Data Link Layer.
    * Packagers data int frames and transmits those frames on the network.
    * Layer 2 devices view networks __logically__.
* ### MAC Address 
    * Media Access Control
    * Physical addressing system of a device which operates on the logical topology.
    * Uses a 48-bit address assigned to a network interface card. 
    * __EX:__ `D2:51:F1:3A:34:65` 
    * `D2:51:F1` is the vendor code 
* ### Logical Link Control
    * Provides connection services and allows acknowledgment of receipt of message.
    * Is the basic form of flow control.
    * Provides basic error control functions.
    * Uses a check sum. 
* ### How communication synchronized.
    * Isochronous
        * Network devices use a common reference a common reference clock source and create time slots for transmission.
    * Synchronous 
        * Network devices agree on clocking method to indicate beginning and end of frames and can use control characters. 
    * Asynchronous
        * Network devices reference their own internal clocks and use start and stop bits 
* ### What Devices are layer 2
    * network cards
    * Bridges
    * Switch
    * MAC Address
---
## __Layer 3__ Packets
* ### Network Layer
    * Forwards traffic (routing) with logical address. 
    * __IP address__ IPv4 IPv6
    * Logical addressing 
        * Ip Addressing  IPv4 and IPv6
    * Switching (Routing)
    * Route discovery and selection
    * Connection Services 
    * Bandwidth usage
    * Multiplexing
* ### How should data be __forward__ or __routed__ 
    * Packet Switching (Most common)
        * Data is divided into packets and then forwarded to is IP address.
    * Circuit Switching
        * Dedicated communication link is established between two devices.
        * It uses one path when the connect established and the whole time the connect is there. 
    * Message Switching
        * Data is divided into messages which may be stored and then forwarded. 
* ### Route Discovery and Selection
    * Manually configured as a static route or dynamically through.
* ### Connection Services
    * Augment Layer 2 connection services to improve reliability
    * Flow Control 
    * Packet reordering
* ### Internet Control Message Protocol
    * Sends error messages and operational information to an IP destination.
        * `Ping`
        * Trace Route `tracert`
* ### Devices 
    * __Routers__ 
    * Multilayer switches
* ### Protocol 
    * __IPv4__
    * __IPv6__ 
    * ICMP

---

## __Layer 4__ - Segments
* ### Transport Layer
    * TCP Transmission Control Protocol
        * Connection-oriented protocol that is a reliable way to transport segments across the network 
        * Will ask for an acknowledgement. 
        * ![TCP](../pics/tcp.png) 
        * This is a Three-way handshake.

    * UDP User Datagram Protocol
        * Connectionless protocol that is an unreliable way to transport segments across the network 
	    * If it dropped, Sender is unaware

    * TCP vs UDP
    * ![TCP vs UDP](../pics/tcp_vs_udp.png)
    * Windowing
        * Allows the clients to adjust the amount opf data in eash segment.
        * Allows you to send more or fewer for eash segment.
    * Buffering
        * Occurs When devices allocate memory to store segments if bandwidth isn't readily avaiable

---
## __Layer 5__ - Session
* Session Layer
    * Keeps conversations separate to prevent intermingling of data
    * Setup
        * Checking of user credentaials and assigning numbers to sessions to help identify them.
        * Some random number that would be assigned. 
    * Maintain
        * Transfer Data (back and forth)
        * Reestablish connedtion
        * Acknowlegde receipt
    * Tear down 
        * Ending of a session after the transfer is done or when the other party disconnects. 
